## Script (Python) "PlonePopoll_getPortletPoll"
##bind container=container
##bind context=context
##bind namespace=
##bind script=script
##bind subpath=traverse_subpath
##parameters=
##title=Get polls to display in portlet
##
from Products.CMFCore.utils import getToolByName

results = []
portal_popoll = getToolByName(context, 'portal_popoll')

selection_mode = portal_popoll.getPortletConfiguration('selection_mode')
number_of_polls = portal_popoll.getPortletConfiguration('number_of_polls')

#we don't want to see the portlet -> return Nothing
if selection_mode == 'hidden':
    return []

#see the last published
elif selection_mode == 'newest':
    results = context.portal_catalog.searchResults(portal_type='PlonePopoll',
                                                   isEnabled=True,
                                                   sort_on='Date',
                                                   sort_order='reverse',
                                                   sort_limit=number_of_polls,
                                                   review_state='published')[:number_of_polls]

#see the last published in the current folder
elif selection_mode == 'branch':
    folder = context
    if not context.isPrincipiaFolderish:
        folder = context.aq_explicit.getParentNode()
    
    results = folder.getFolderContents({'portal_type':'PlonePopoll', 
                                        'review_state': 'published',
                                        'isEnabled' : True}, 
              )
    sort_on = (('effective', 'cmp', 'desc'), )
    if results:
        results = sequence.sort(results, sort_on)[:number_of_polls]


#see the last published in the current folder OR in its sub-folder
elif selection_mode == 'subbranches':
    folder = context
    if not context.isPrincipiaFolderish:
        folder = context.aq_explicit.getParentNode()
        
    results = context.portal_catalog.searchResults(portal_type='PlonePopoll',
                                                   isEnabled=True,
                                                   path='/'.join(folder.getPhysicalPath()),
                                                   sort_on='Date',
                                                   sort_order='reverse',
                                                   sort_limit=number_of_polls,
                                                   review_state='published')[:number_of_polls]
else:
    # Path to plonePopoll object
    results = context.portal_catalog.searchResults(portal_type='PlonePopoll',
                                                   isEnabled=True,
                                                   path=selection_mode,
                                                   review_state='published')

if len(results) > 0:
    # really use getObject, because poll portlet requires full objects
    results = [ result.getObject() for result in results]

return results
